
const fireworksObject = function(x,y,target){
this.x =x;
this.y=y;
this.direction=null;
this.target={x:target.x,y:target.y}
//number of particles to release on explosion;
this.count=20;
this.speed=10;
this.particle_life=[10,30];
this.particle_speed=[1,5];
this.segments=[];
this.segment_limit=5;
this.init()
}
fireworksObject.prototype={
init:function(){
    
    this.segments.push({x:this.x,y:this.y});
    var dx=this.target.x-this.x;
    var dy=this.target.y-this.y;
    var magnitude=Math.sqrt(dx*dx+dy*dy);
    //normalized direction
    var nx=dx/magnitude;
    var ny=dy/magnitude;

    this.direction={x:nx,y:ny};
},
explode:function(fireworks,particles,canvas){
    var index=fireworks.findIndex(item =>item ==this);
    fireworks.splice(index,1);
    var i=0;
    while(i<this.count){
        var x0=Math.random(0,1)*canvas.width;
        var y0=Math.random(0,1)*canvas.height;
        var life=Math.random(0,1)*this.particle_life[1]+this.particle_life[0];
        var speed=Math.random(0,1)*this.particle_speed[1]+this.particle_speed[0];
        particles.push(create_particle(this.x,this.y,life,speed,{x:x0,y:y0}));
        i++;
    }
    delete(this);
},
move:function(){

    this.x+=this.speed*this.direction.x;
    this.y+=this.speed*this.direction.y;
}
,
update:function(gl,fireworks,particles,canvas){
    //move the fireworks
    this.move();
    //drawing the fire works;
    gl.beginPath();
    gl.strokeStyle=`hsl(${Math.random() * 5000}, 100%, 50%)`;
    gl.lineWidth=Math.random(0,1)*2+1;
    var last_pos=this.segments[this.segments.length-1];

    gl.moveTo(last_pos.x, last_pos.y);
    gl.lineTo(this.x,this.y);
 

    gl.stroke();
    gl.closePath();
    this.segments.push({x:this.x,y:this.y})
    if(this.segments.length>=this.segment_limit){
       this.segments.splice(0,1);
    }
    var dx=this.target.x-this.x;
    var dy=this.target.y-this.y;
    var distance=Math.sqrt(dx*dx+dy*dy)
    if(distance<=10){
        this.explode(fireworks,particles,canvas);
    }

}
}
function create_fireworks(x,y,target){
    return new fireworksObject(x,y,target);
}
const particle = function(x,y,life,speed,target){
    this.x=x;
    this.y=y;
    this.life=life;
    this.decay=1;
    this.direction=null;
   
    this.target={x:target.x,y:target.y};
    this.speed=speed;
    this.gravity=2;
    this.segments=[];
    this.segment_limit=5;
    this.init();
    }
particle.prototype={
    init:function(){
    
        this.segments.push({x:this.x,y:this.y});
        var dx=this.target.x-this.x;
        var dy=this.target.y-this.y;
        var magnitude=Math.sqrt(dx*dx+dy*dy);
        //normalized direction
        var nx=dx/magnitude;
        var ny=dy/magnitude;
    
        this.direction={x:nx,y:ny};
    },
    end:function(particles){
        
        var index=particles.findIndex(item =>item ==this);
       
        particles.splice(index,1);
        delete(this);
    },
    move:function(){
    
        this.x+=this.speed*this.direction.x;
        this.y+=this.speed*this.direction.y+this.gravity;
    }
    ,
    update:function(gl,particles){
        //move the fireworks
        this.move();
        //drawing the fire works;
        gl.beginPath();
        gl.strokeStyle=`hsl(${Math.random() * 360}, 100%, 50%)`;
        gl.lineWidth=Math.random(0,1)*2+1;
        var last_pos=this.segments[this.segments.length-1];
    
        gl.moveTo(last_pos.x, last_pos.y);
        gl.lineTo(this.x,this.y);
     
    
        gl.stroke();
        gl.closePath();
        this.segments.push({x:this.x,y:this.y})
        if(this.segments.length>=this.segment_limit){
           this.segments.splice(0,1);
        }
        this.life-=this.decay;
        if(this.life<=0){
            this.end(particles);
        }
       
    
    }
}

function create_particle(x,y,life,speed,target){
    return new particle(x,y,life,speed,target);
}
